# Peony 
## Overview
The peony can view files and folders on the system categorically, supporting common operations for files and folders, and its main interface is shown in figure below.

![Fig 1 Peony-big](image/1.png)

## Basic Function
### File Name

(1)The maximum length of the system file name can be 255 characters, usually by letters, numbers, "."(dotted), "_"(underlined) and "-"(minus).

(2)"-"cannot be the first letter of a file name.

(3)File names cannot contain the "/"symbol; because "/"is in the operating system directory tree and indicates a separator symbol in the root directory or path.

### Path
(1)When using a file in the current directory, users can quote the file name directly; if users want to use a file in another directory, users must specify the directory where the file is located.

(2)The absolute path is certain and the relative path changes with the user's working directory.

Absolute path —— A path from the root directory, such as "/home/kylin/test"

Relative path —— The path from the current directory.For example, when located in the /home directory, the relative path of the test file is "kylin/test"

(3)The "."file representing the current directory and the ".."file representing the directory level above the current directory.

When located in the /etc directory, the relative path of the test file is represented as... "/home/kylin/test"

### File Type
The system supports file types such as those in table below. 

|File type| Description
| :------------ | :------------ |
| General files| Includes text files, data files, executable binaries, etc
| Contents files(contents)|The system views the directory as a special file and uses it to form a hierarchical tree structure of the file system
| Equipment files(Character device file/block device file)|The system uses it to identify individual device drivers, which the kernel uses to communicate with hardware devices
|Symbolic link|Stored data is the path to a file in the file system;When a symbolic link file is invoked, the system will automatically access the paths saved in the file

<br>

## Window Composition
The Peony window can be divided into the toolbar and address bar, the folder label preview area, the sidebar, the window area and status bar, and the preview window in six sections.

![Fig 2 Window partitioning diagram-big](image/2.png)

### Toolbar And Address Bar
The functions corresponding to the icons on the toolbar are shown in table below.

|Icons|Description|Icons|Description
| :------------ | :------------ | :------------ | :------------ |
|![](image/icon2.png)|Return to previous level|![](image/icon8.png)|Retreat
|![](image/icon3.png)|Search folders,files, etc. with advanced search functions|![](image/icon9.png)|Select the view mode (small icon, medium icon, large icon)
|![](image/icon4.png)|Select the sorting method (name, modification date, etc.)|![](image/icon10.png)|Advanced features
|![](image/icon5.png)|Minimize|![](image/icon11.png)|Maximize
|![](image/icon6.png)|Close||||

<br>

### Folder Tag Preview Area
Users can view open folders through the folder tab preview area and are able to add additional folders by clicking the "![](image/icon12-o.png)"icon to add additional folders.

![Fig 3 Folder Label Preview Area](image/3.png)

### Sidebar
The sidebar lists the directory hierarchy for all files, providing a view of the different types of folder directories in users operating system.External mobile devices, remotely connected shared devices are also shown here.

![Fig 4 Peony Sidebar](image/4.png)

### Window Area
The window area lists the subdirectories, files under the current directory node.In the sidebar list, click on a directory, the contents of which should be displayed here, the contents should be displayed here, with the file icon highlighted to indicate that the file is selected.

![Fig 5 window area-big](image/5.png)

### Status Bar
(1)When entering a directory, the number of files in the current location is displayed.

(2)When a folder is selected, the number of files in that folder is displayed.

(3)When a file is selected, the type and size of that file is displayed.

(4)The slider in the bottom right corner is a zoom bar that can be dragged to adjust the file size.

![Fig 6 Status bar-big](image/6.png)

### Preview Window
Click on the preview icon in the upper right corner of the preview window to preview the details of the file, to the picture file as an example.In the preview window users can view the image name, type, size, creation time, resolution and other information, and underneath the image information, users can also rotate, edit, delete and other operations on the image.

|Icons|Description|
| :------------ | :------------ | 
|![](image/icon14.png)|Document Preview Only

<br>

![Fig 7 Preview window](image/7.png)
<br>

## Main Function
### View 
Users can use the peony to view and manage files on local files, local storage devices (such as external hard drives), file servers and network shares.

In the peony , double-click any folder to view its contents (by default application);Or right-click a folder to open it in a new tab or new window.

#### View mode
By default, the system displays all files and directories in the form of icons.

The user can select the file view mode by clicking the "![](image/icon16-o.png)"icon to select the file view mode, the icon can be set to: large icon, small icon, list, details, tiled five modes.

![Fig 8 View Mode](image/8.png)

In the icon view, files in the peony are displayed as <big icon + file name>, like Fig 1.

![Fig 9 Icon view-big](image/9.png)

In the list view, files in the  peony are displayed as <small icon + file name + file information>.

![Fig 10 List view-big](image/10.png)

#### Sort By
Files can be sorted in different ways while browsing. The way the files are arranged depends on the folder view method currently in use, and the user can change it by clicking the "![](image/icon4.png)"icon on the toolbar to change it.

![Fig 11 Sorted by-big](image/11.png)

The various documents are sorted as follows:

(1)Sort by name: Alphabetical order by file name.

(2)Sort by modification date: Sort by the date and time the file was last changed; by default it is sorted from oldest to newest.

(3)Sort by type: files are sorted alphabetically by file type; similar files are grouped together and then sorted by name.

(4)Sort by size: Sort by file size; by default it is sorted from smallest to largest.

(5)Sort by ascending/descending: Sort in order from smallest to largest or from largest to smallest, depending on the corresponding type.

(6)Marker Filtering: Filter out files and folders in the current directory that have been marked with the same color.

![Fig 12 Mark sort-big](image/12.png)

### Search and Filter Functions
The File Browser provides users with search and filter functions.

The search function, i.e., clicking on the “![](image/icon3.png)” icon button, you can switch to the search input box.

Type in the search box and press enter, or wait a moment (less than 1 second) to search for files in the current directory.

![Fig 13 Search Function-big](image/13.png)

Filtering function: In the current directory or the searched files, users can customize the conditions, according to the name corresponds to the keywords, the type corresponds to the file type, the file size corresponds to the size of the file to be searched, the modification time corresponds to a certain period of time and so on for filtering. The filter function can only filter files in the current directory or after searching, it does not include the filtering of sub-folders in the current directory.

![Fig 14 Filter box-big](image/14.png)

Expanding all types of filter criteria results in the pop-up window shown below.

![Fig 15 All types of filters-big](image/15.png)

### Common operations with files and folders
(1)Copy
* Way 1:Check, right-click > "Copy"> Target, right-click > "Paste"
* Way 2:Check, Ctrl+C > Target, Ctrl+V
* Way 3:Drag from the folder window where the project is located to the destination folder window

In way 3, if both folders are on the same hard disk device on the computer, the item is moved;If dragged from a USB stick to the system folder, the item will be copied.To drag copy on the same device, users need to hold down "Ctrl"while dragging.

(2)Move
* Way 1:Check, right-click > "Cut"> Target, right-click > "Paste"
* Way 2:Check, Ctrl+X > Target, Ctrl+V

(3)Delete

**Delete to recycling:**
* Way 1:Check, right-click > "Delete"
* Way 2:Selected, Delete
* Way 3:Select it and drag it to the "Trash"on the desktop

If the deleted files are on removable devices, or some remote directories and special directories, the deletion option is to delete permanently, and the local file deletion option is to delete to the Recycle bin, where the deleted files can be seen.

**Delete permanently:**
* Way 1:Delete again in the "Trash"
* Way 2:Selected, Shift+Delete

(4)Rename
* Way 1:Check, right-click > "Rename"
* Way 2:Selected, F2

To undo a rename, press Ctrl+Z to restore it.
### Formatting And Unloading Equipment
In the sidebar, for the device accessing the system, right-click and the menu appears as shown in figure below.

![Fig 16 Mobile device right-click menu](image/16.png)

* Unload/pop:Both of these serve the purpose of offloading mobile devices.The difference is that the device still exists in the system after uninstallation (unmounted state) and can no longer be found in the system when ejected.The "![](image/icon18-o.png)"button on the right side of the device is the pop-up role.
* Formatting:System default format is FAT32 file system, users can change to Ext2/3/4 or NTFS format;To use this feature, users need to uninstall the device first.
* Rename: It supports renaming mobile devices (e.g., USB flash drives, removable hard disks and other devices) and renaming partitions, some partitions are not supported for the time being (e.g., file system partitions, data disks, etc.).
* Encrypt Disk/(Cancel Encryption, Change Password, Lock Disk): Encrypt the current disk for higher security file protection. For the encrypted disk, the right-click menu will show Cancel Encryption, Change Password, Lock Disk. Cancel Encryption: Cancel the encryption of the disk, in addition, it may lead to the loss of files in the disk, please save the files first. Change Password: Change the password that you entered when encrypting the disk, enter the original password and re-enter the new password to change the encryption password. Lock Disk: Lock the disk, after the disk is locked, you need to verify the encryption password when you want to access the files in the disk, in addition, during the process of locking the disk, it may lead to the loss of the files being used, please save the files first.

![Fig 17 Formatted](image/17.png)

### Access Network
Used to share files over a LAN.

Exp:Right-click "Music", select "Share", and a dialog box will pop up.18.Users can set information and permissions for shared folders.

![Fig 18 Share option-big](image/18.png)

(1)After setting the sharing option, clicking Confirm will set the sharing and the window will close automatically, or not set if canceled.

(2)On another system on the same LAN, open a peony , select "Browse Network"and find the host name of the shared file.When opened, users can see the file that was shared. Double-click the file to bring up the connection prompt box.

![Fig 19 Connect-tip-big](image/19.png)

(3)After connecting, the contents of the shared file can be seen, and the connected host is also displayed in the sidebar.

![Fig 20 Shared folder contents-big](image/20.png)

(4)If users want to stop sharing the folder, users can right-click the folder again, and uncheck the sharing.

<br>

## Advanced Settings
Click the "![](image/icon10.png)"icon on the toolbar to enter the setup interface.

Advanced settings are the peony preferences.21,Preferences are divided into three parts: editing tools, setup items, and manual instructions.

(1)Edit: copy, paste, cut and delete

(2)Settings: Keep Allow, Show Hidden, Show File Extension, Show Create Time, Show Relative Time, Forbid thumbnailing, Index Settings, Resident in Backend,Parallel Operations, Set samba password, Open each folder in a new window, Plugin manager Settings, Connect to Server, Show Network, Local Disk Show Unmount Opt

(3)Manuals and Instructions: Help, About, Feedback

|Icons|Description|Icons|Description
| :------------ | :------------ | :------------ | :------------ |
|![](image/icon20.png)|	Reproduction of selected projects|![](image/icon21.png)|	Paste selected items
|![](image/icon22.png)|Cut the selected item|![](image/icon23.png)|Trash, empty all items

<br>

![Fig 21 Tools and settings](image/21.png)

The configurable content contains several aspects, each tab corresponds to a brief description of the functionality.

|Tabs|Description
| :------------ | :------------ |
|Keep Allow|Place the peony window on the top level for display
|Show Hidden|Whether the file starting with "." is displayed
|Show File Extension|Whether the file extension is displayed
|Show Create Time|Whether the file creation time is displayed
|Show Relative Time|Whether the file creation time is displayed
|Forbid thumbnailing|Whether to display the preview thumbnails of pictures, videos, and wps office files
|Index Settings|Jump to the Global Index Settings page of the ukui-control-center
|Resident in Backend|Whether the file manager program has been kept in the background without completely exiting
|Parallel Operations|Whether multiple file operations can be performed simultaneously
|Set samba password|You can set the samba password for the current user
|Open each folder in a new window|Whether a new window opens when the folder is opened
|Plugin manager Settings|Manage whether the plugin for the file manager is loaded
|Connect to Server|Displays the interface for connecting to the remote server
|Show Network|Whether sidebar network entries and computer view network entries are displayed
|Local Disk Show Unmount Opt|Whether to display the unmount option for local disks
|Help|Jump to User Manual
|About|Show details of the peony 
|Feedback|Open the Feedback window of kylin-os-manager, you can submit suggestions or comments about the file manager

<br>

## File safe box
The “File safe” shown in the sidebar is a plug-in for the Protect Box application, which is integrated into the File Manager and provides an entry point for the operation of the Protect Box in the sidebar. For details of its functions and operation, please refer to the Protect Box manual.

![Fig 22 File safe box-big](image/22.png)

## Appendix
### 1 Shortcuts

|Shortcut key|Function|
| :------------ | :------------ |
| Ctrl+C|Copy |
| Ctrl+X|Cut|
| Ctrl+V|Paste|
| Delete|Delete|
| Shift+Delete|Permanent deletion|
| Ctrl+Z |Revoke|
| Ctrl+A|All|
| F2| Rename|
| Alt+D|Edit Address|

### 2 Wildcard Descriptions

|Wildcard|Description
| :------------ | :------------ |
|Asterisks（*）|Match zero or more characters|
|question mark（?）|Match any of the characters|
|[abl A-F]|Match any of the characters listed in square brackets, for example a, b, l or any of the uppercase characters from A to F|

### 3 Brief description of the system section

（1）/bin:Store command files that can be used by regular users.

（2）/boot:Contains files used by the kernel and other system programs when they start.

（3）/dev:The directory where the device files are located. The device is managed as a file in the operating system and can be manipulated as an operating file.

（4）/etc:The system's configuration file.

（5）/home:The location of the user's home directory, where user files are saved, including configuration files, documents, etc.

（6）/lib:Contains many shared library files that are used by programs in /bin.

（7）/opt:Store the files and programs that can be optionally installed, mainly by third-party developers to install their packages.

（8）/root:The home directory of the system administrator (root or superuser).

（9）/usr:Includes files and directories that are directly relevant to system users, and some major applications are also stored in this directory.

（10）/var:Contains some documents that change frequently. Such as false offline (spool) directories, file log directories, lock files, and temporary files.
